<?php
define('FRAMEWORKPATH', BASEPATH . '/vendor/4lt/novaconium');

require_once(BASEPATH . '/vendor/autoload.php');

//Check if config file exists
if (file_exists(BASEPATH . '/App/config.php')) {
    require_once(BASEPATH . '/App/config.php');
} else {
    require_once(FRAMEWORKPATH . '/defaults/App/config.php');
}

// Logging
require_once(FRAMEWORKPATH . '/src/Logger.php');
$log = new Logger(BASEPATH . $config['logfile'], $config['loglevel']);

// Global Functions
require_once(FRAMEWORKPATH . '/src/functions.php');

// Creates the view() function using twig
$data = array();
require_once(FRAMEWORKPATH . '/src/twig.php');

// Start a Session
require_once(FRAMEWORKPATH . '/src/Session.php');
$session = new Session();
$data['token'] = $session->get('token');
if ($config['loglevel'] == 'DEBUG') {
    $data['debug'] = nl2br(print_r($session->debug(), true));
}

// Messages
require_once(FRAMEWORKPATH . '/src/MessageHandler.php');
$messages = new MessageHandler($session->flash('messages'));

foreach (['error','notice'] as $key){
   $data[$key] = $messages->showMessages($key);
}

// Load Database Class
if (!empty($config['database']['host'])) {
    require_once(FRAMEWORKPATH . '/src/Database.php');
    $db = new Database($config['database']);
}

// Sanatize POST Data
if (!empty($_POST)) {
    require_once(FRAMEWORKPATH . '/src/Post.php');
    $post = new POST($_POST);
}

// Start a Redirect
require_once(FRAMEWORKPATH . '/src/Redirect.php');
$redirect = new Redirect();

// Load a controller
require_once(FRAMEWORKPATH . '/src/Router.php');
$router = new Router();
//$router->debug();
require_once($router->controllerPath);

makeitso();
